/*!
  @file
  @author Shin'ichiro Nakaoka
*/

#include <cnoid/Config>
#include <cnoid/App>
#include <QIcon>
#include <cstdlib>

using namespace std;
using namespace cnoid;


int main(int argc, char *argv[])
{
    cnoid::App app(argc, argv);

    QIcon icon;
    icon.addFile(":/Icons/icon/choreonoid32.png");
    icon.addFile(":/Icons/icon/choreonoid48.png");
    
    app.initialize("Choreonoid", "Choreonoid", icon, getenv("CNOID_PLUGIN_PATH"));
    
    app.exec();
    
    return 0;
}


#ifdef WIN32

#include <windows.h>
#include <vector>
#include <boost/tokenizer.hpp>

using namespace boost;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
#ifndef UNICODE
    string cmdline(lpCmdLine);
#else
    string cmdline;
    const int size = WideCharToMultiByte(CP_UTF8, 0, lpCmdLine, -1, NULL, 0, NULL, NULL);
    if(size > 0){
        cmdline.resize(size);
        WideCharToMultiByte(CP_UTF8, 0, execFilePath, -1, &cmdline[0], size, NULL, NULL);
    }
#endif

    int argc = 1;
    vector<char*> argv;
    argv.push_back("appname");
  
    char_separator<char> sep(" ");
    tokenizer< char_separator<char> > cmds(cmdline, sep);
    tokenizer< char_separator<char> >::iterator p;
    for(p = cmds.begin(); p != cmds.end(); ++p){
        const string& cmd = *p;
        argc++;
        char* arg = new char[cmd.size()+1];
        strcpy(arg, cmd.c_str());
        argv.push_back(arg);
    }
  
    return main(argc, &argv[0]);
}
#endif
